// Purpose: Win32 GUI application  Ŭ 
// Author : ڱ
// Update : 2003/05/20
// Date   : 2003/04/28
// Comment:
//      Win32 GUI ǥϴ  Ŭ ַ Win32 API WrapperԼ ޼
//      óԼ Ǿ ִ.
//       Ŭ ε GUI ǥ   Ϲ C_Frame Ŭ
//      ϸ SDI, MDI 츦     ִ. 
//
//  Windows  ޼ ߻ 
//  WM_GETMINMAXINFO    36
//  WM_NCCREATE         129
//  WM_NCCALCSIZE       131
//  WM_CREATE           1
//   ޼... 
//  WM_DESTROY          2
//  WM_NCDESTROY        130

#if defined(_WIN32) && defined(_GUI)

#ifndef __WND_H_ 
#define __WND_H_

//
// Includes
//

#include <pesc.h>

//
// Definitions
//

// Message map

#define DECLARE_MESSAGE_MAP() \
    private: \
        static const MSD rgmsd[];   \
    protected: \
        static const MSDM messageMap;  \
        virtual const MSDM* GetMessageMap() const;

#define BEGIN_MESSAGE_MAP(CLASS, BASECLASS) \
    const C_Wnd::MSDM* CLASS::GetMessageMap() const    \
        { return &CLASS::messageMap; }  \
    const C_Wnd::MSDM CLASS::messageMap = \
        { &BASECLASS::messageMap, CLASS::rgmsd };   \
    const C_Wnd::MSD CLASS::rgmsd[] = {

#define END_MESSAGE_MAP() \
    {0, 0, 0, 0}, \
};

#define ON_MESSAGE(MESSAGE, FUNCTION)   \
    { MESSAGE, 0, (LRESULT (C_Wnd::*)(WPARAM, LPARAM))&FUNCTION, 0 },

#define ON_COMMAND(MESSAGE, FUNCTION)   \
    { WM_COMMAND, MESSAGE, 0, (LRESULT (C_Wnd::*)(WORD, HWND))&FUNCTION },

// MDI   

#define MDICLIENT       "MDICLIENT"
#define ID_FIRSTCHILD   64000

//
// Class
//

class C_Wnd
{
// Constants, Enumerations & Structures
protected:
    // ȣؾ ϴ ⺻  ν  
    typedef enum
    {
        edwpNone,           // ⺻  ν ȣ ʴ´.
                            // (ǥ ȭڿ) 
        edwpWindow,         // Call DefWindowProc.
        edwpDialog,         // Call DefDlgProc (custom ȭڿ)
        edwpMDIChild,       // Call DefMDIChildProc.
        edwpMDIFrame        // Call DefFrameProc.
    } EDWP;					// Enumeration for Default Window Procedures
    
private:
    // Message ڵ鸵 Լ  Լ  prototype
    typedef LRESULT (C_Wnd::*PFNMSG)(WPARAM,LPARAM);

    // Command ڵ鸵 Լ  Լ  prototype    
    typedef LRESULT (C_Wnd::*PFNCMD)(WORD,HWND);

    // ޼ Լ   ִ ü 
    typedef struct _MSD
    {
        UINT   uMessage;    // ޼ 
        WORD   wCommand;    // WM_COMMAND϶  
        PFNMSG pfnmsg;      // ޼ Լ 
        PFNCMD pfncmd;      //  Լ 
        
    } MSD;  // MeSsage Dispatch structure

    typedef struct _MSDM
    {
        const   _MSDM*  baseMsd;
        const   MSD*    Msd;
    } MSDM; // MeSsage Dispatch structure Map

    // WndProc DispMessage ͸ Ѱٶ ʿ   
    typedef struct _MSDI
    {
        int  cmsd;          // ޼  
        MSD *rgmsd;         // ޼ Լ   ִ ü 
        EDWP edwp;          // ʿ ϴ ⺻  ν 
    } MSDI, FAR *LPMSDI;	// MeSsage Dipatch Information

// Constructors & Destructors
public:
    C_Wnd();
    ~C_Wnd(); 

// Operators
public:

// Attributes
private:
    static  HHOOK   m_hHook;

protected:
    EDWP    m_edwp;
    HWND    m_hWnd;         // Window handle
    HWND    m_hWndClient;   // Client window handle
    HMENU   m_hMenu;
    HMENU   m_hMenuList;    // Window list menu

// Overridables
public:
    virtual bool PreCreateWindow(CREATESTRUCT& cs);

    virtual LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
    virtual LRESULT OnNCDestroy(WPARAM wParam, LPARAM lParam);
    
    virtual LRESULT CmdFileExit(WORD wNotify, HWND hwndCtrl);
    virtual LRESULT CmdWindowTile(WORD wNotify, HWND hwndCtrl);
    virtual LRESULT CmdWindowCascade(WORD wNotify, HWND hwndCtrl);
    virtual LRESULT CmdWindowArrange(WORD wNotify, HWND hwndCtrl);

// Methods
    DECLARE_MESSAGE_MAP()
private:
    LRESULT DispMessage(UINT uMessage, WPARAM wParam, LPARAM lParam);
   	LRESULT DispDefault(UINT uMessage, WPARAM wparam, LPARAM lparam);

    static LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam,
        LPARAM lParam);
    static LRESULT CALLBACK CBTProc(int iCode, WPARAM wParam, LPARAM lParam);
   	
public:
    void Attach(HWND hWnd);
    // Purpose:  ڵ ȯѴ. 
    // Returns:  ڵ
    HWND GetHandle() { return m_hWnd; }
    HWND GetHandleClient() { return m_hWndClient; }
    // Purpose: ޴ ڵ ȯѴ.
    HMENU GetMenu() { return m_hMenu; }
    HMENU GetMenuList() { return m_hMenuList; }
    // Purpose:    ڵ Ŭ Ѵ.
    // Accepts: hWnd- Ϸ  ڵ 
    void RemoveFromMap(HWND hWnd)
    {
        m_hWnd = NULL;
        PescGetWndMap()->RemoveHandle(hWnd);
    } 
    //C_Wnd* GetClassPointer() { return this; }
    bool RegisterClassWithIcon(LPCSTR c_lpszClassName, UINT nIDResource,
        UINT nClassStyle, HBRUSH hbrBackground = 0);

    //
    // API Wrapper Լ
    //
    
    bool RegisterClass(LPCSTR c_lpszClassName, UINT nClassStyle,
        HCURSOR hCursor = 0, HBRUSH hbrBackground = 0, HICON hIcon = 0);
    bool CreateWindowEx(DWORD dwExStyle, LPCSTR c_lpszClassName, 
	   LPCSTR c_lpszWindowName, DWORD dwStyle,
	   int x, int y, int nWidth, int nHeight,
	   HWND hWndParent, HMENU nIDorHMenu, LPVOID lpParam = NULL);

    LRESULT SendMessageClient(UINT uMsg, WPARAM wParam = 0, LPARAM lParam = 0);

    //
    // API Wrapper inline Լ 
    //
    
    LRESULT SendMessage(UINT uMsg, WPARAM wParam = 0, LPARAM lParam = 0);
    bool LoadMenu(UINT nIDResource);
    bool GetSubMenu(UINT nWindowListPos);
    BOOL ShowWindow(int iCmdShow = SW_SHOWDEFAULT);
    bool UpdateWindow();
    bool DestroyWindow();
    bool GetClientRect(LPRECT lpRect);
    bool BringWindowToTop();
    bool EnumChildWindows(WNDENUMPROC lpEnumFunc, LPARAM lParam = 0);
    HWND GetWindow(UINT uCmd);

};

#endif  // __WND_H_

#endif  // _WIN32, _GUI
